<template>
  <section class="login-page container">

    <a v-if="step === 2"
       href="javascript:void(0)"
       class="login-page__back"
       @click="goToStep(1)"
    >
      <icon-arrow /> Вернуться назад
    </a>

    <form v-show="step === 1"
          novalidate
          class="login-form login-form--phone"
          @submit.prevent="sendPhoneForm"
    >
      <h3 class="login-form__title">Вход</h3>

      <p class="login-form__label">
        Авторизуйтесь, чтобы войти в&nbsp;личный&nbsp;кабинет
      </p>

      <form-input :mask="true"
                  mask-type="phone-mask"
                  :error="phoneError"
                  :label="phoneError ? `Телефон введен неверно` : 'Введите телефон'"
                  v-model="phone"
                  type="tel"
      />
      <meta name="format-detection" content="telephone=no">
      <button type="submit"
              class="login-form__btn button button--green">
        Войти
      </button>

      <single-checkbox class="login-form__confirm"
                       v-model="rights"
                       :error="!rights"
                       name="rights">
        Я согласен(-на) с условиями <a href="/user_agreement.pdf" target="_blank">договора об использовании платформы</a>
        и <a href="/privacy_policy.pdf" target="_blank">политикой обработки персональных данных</a>.
      </single-checkbox>

      <recaptcha @error="onError" @success="onSuccessPhone" />
    </form>

    <form v-show="step === 2"
          class="login-form"
    >
      <h3 class="login-form__title">Вход</h3>

      <p class="login-form__label">
        Вам отправлен код подтверждения
        на номер: <b>{{ maskedPhone }}</b>
      </p>

      <form-input :mask="true"
                  :error="codeError"
                  :label="codeError ? 'Код введен неверно' : 'Введите код из смс'"
                  type="password"
                  mask-type="sms-code-mask"
                  v-model="code"
      />

      <button type="button"
              class="login-form__btn button button--green"
              @click="sendPhoneForm()"
              :disabled="timerCount > 0"
      >
        Отправить еще раз
        <template v-if="timerCount > 0">
          ({{ `0${Math.floor(timerCount / 60)}:${timerCount % 60 >= 10 ? `${timerCount % 60}` : `0${timerCount % 60}`}`}})
        </template>
      </button>
    </form>


  </section>
</template>

<script>
  import { mapActions } from 'vuex';

  import FormInput from '../components/FormInput';
  import IconArrow from '../components/icons/IconArrow';
  import SingleCheckbox from '../components/SingleCheckbox';

  import { login as loginRequest, getSeoBySlug } from '../service/deliroom-service';

  export default {
    name: 'LoginPage',
    middleware: 'login',
    components: {
      SingleCheckbox,
      IconArrow,
      FormInput
    },
    data: () => ({
      phone: '',
      maskedPhone: '',
      sendedPhone: '',
      captchaPhone: '',
      code: '',
      step: 1,
      phoneError: false,
      codeError: false,
      timerCount: 0,
      rights: true,
    }),

    asyncData: async () => ({
      meta: await getSeoBySlug('/login'),
    }),

    watch: {
      phone() {
        this.phoneError = false;
      },

      code(val) {
        if (val.length === 4) this.sendCodeForm();

        this.codeError = false;
      }
    },
    methods: {
      ...mapActions({
        authRequest: 'auth/authRequest'
      }),

      onError(error) {
        console.log('Error happened:', error)
      },

      async onSuccessPhone() {
        const timer = setInterval(async () => {
          if (this.captchaPhone) {
            clearInterval(timer);

            await this.getCodeByPhone();
          }
        }, 100);
      },

      async sendPhoneForm() {
        if (this.phone.length && this.sendedPhone === this.phone && this.step === 1) {
          this.goToStep(2);

          return;
        }

        if (!this.phone) {
          this.phoneError = true;
          return;
        }

        if (!this.rights) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: 'Не дано согласие на обработку данных',
          });

          return;
        }

        this.captchaPhone = '';

        try {
          this.captchaPhone = await this.$recaptcha.getResponse();
          await this.$recaptcha.reset()
        } catch (error) {
          console.log('Login error:', error)
        }
      },

      async sendCodeForm() {
        if (!this.rights) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: 'Не дано согласие на обработку данных',
          });

          return;
        }

        await this.login();
      },

      async getCodeByPhone() {
        this.code = '';

        const res = await loginRequest({ phone: `+7${ this.phone }`, captcha: this.captchaPhone });

        if (res.errors || res.error) {
          this.phoneError = true;
          console.error(res.errors);

          return;
        }

        const expiredAt = (new Date(res.data.expired_at) - new Date()) / 1000;

        this.sendedPhone = this.phone;
        this.startCounting(expiredAt);
        this.maskedPhone = this.$el.querySelector('.login-form.login-form--phone input').value;
        this.goToStep(2);
      },

      async login() {
        const res = await this.authRequest({
          phone: `+7${ this.phone }`,
          sms_code: this.code,
        });

        if (res.error) {
          this.codeError = true;
          console.error(res.error);

          return;
        }

        this.$gtm.push({ event: 'authorization' });

        if (this.$route.query.place) {
          this.$router.push({ path: `/places/${this.$route.query.place}` })
        } else if (this.$route.query.checkout) {
          this.$router.push({path: `/checkout/${this.$route.query.checkout}`})
        } else {
          this.$router.push({ path: '/personal/profile' })
        }

        window.scrollTo({top: 0, behavior: 'smooth'});
      },

      goToStep(step) {
        this.step = step;
        this.code = '';
      },

      startCounting(count = 60) {
        this.timerCount = Math.ceil(count);

        const timer = setInterval(() => {
          this.timerCount--;

          if (this.timerCount <= 0) {
            clearInterval(timer)
          }
        }, 1000)
      }
    },

    head() {
      if (!this.meta) return;

      return {
        title: this.meta.title,
        meta: this.meta.meta.map((metaItem) => ({
          ...metaItem,
          hid: metaItem.name.toLowerCase(),
          name: metaItem.name.toLowerCase(),
        })),
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .login-page {
    padding-top: rem(30);
    padding-bottom: rem(20);

    .login-form {
      @include gray-btn;

      max-width: rem(368);
      margin: 0 auto;
      padding: rem(40);

      border-radius: rem(8);

      &__title {
        @include h3;
        text-align: center;

        margin-bottom: rem(8);
      }

      &__label {
        @include p2;
        text-align: center;

        margin-bottom: rem(24);

        b {
          color: $black;
          text-decoration: none;

          a {
            color: $black;
          }
        }
      }

      &__btn {
        width: 100%;
        margin: rem(30) 0 rem(20);
      }

      &__confirm {
        @include p3;

        margin-top: rem(30);

        a {
          color: $black;

          &:hover {
            color: rgba($black, .5);
          }
        }
      }

    }

    &__back {
      @include p2;

      display: block;
      margin-bottom: rem(30);

      color: rgba($black, .5);
      text-align: center;

      svg {
        margin-right: rem(12);
      }
    }
  }

</style>

